package is.test;

import is.splines.CubicSpline;

import java.awt.Color;
import java.awt.Container;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.geom.Point2D;
import java.util.ArrayList;

import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;

public class TestApp extends JFrame {
	
	public TestApp(){
		super();
		
		addMenuBar();
		setContentPane(new JPanel(){
			@Override
			public void paint(Graphics g){
				Graphics2D g2 = (Graphics2D)g;
				
				g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
				
				ArrayList<Point2D> points = new ArrayList<Point2D>();
				points.add(new Point2D.Float(100, 100));
				points.add(new Point2D.Float(330, 120));
				points.add(new Point2D.Float(380, 420));
				points.add(new Point2D.Float(310, 540));
				points.add(new Point2D.Float(400, 100));
				points.add(new Point2D.Float(600, 200));
				
				CubicSpline spline = new CubicSpline();
				spline.setPoints(points);
				
				g2.setColor(Color.BLACK);
				g2.draw(spline.getShape()); // Draw the main points of the curve as rectangles
				for(Point2D p:spline.getPathPoints()) g2.drawRect((int)p.getX() - 3, (int)p.getY() - 3, 6, 6);
				
				g2.setColor(Color.RED); // Draw the additional control points as small red ovals
				for(Point2D p:spline.getControlPoints()) g2.drawOval((int)p.getX() - 2, (int)p.getY() - 2, 4, 4);
			}
		});
		
        setBounds(200, 100, 800, 700);
        setBackground(Color.WHITE);
        setVisible(true); 
	}
	
	

	public static void main(String[] args) {
		TestApp frame = new TestApp();
		
		frame.addWindowListener(new WindowAdapter() {
		    public void windowClosing(WindowEvent e) {
		        System.exit(0);
		    }
		});
	}
	

	private void addMenuBar(){
		JMenuBar menuBar = new JMenuBar();
		JMenu fileMenu = new JMenu("File");
		
		JMenuItem exitItem = new JMenuItem("Quit");
		exitItem.addActionListener( new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}
		});	
		
		fileMenu.add(exitItem);		
		menuBar.add(fileMenu);
				
		this.setJMenuBar(menuBar);
	}
	
}
